codeforces 767C Garland

Once at New Year Dima had a dream in which he was presented a fairy garland. A garland is a set of lamps, some pairs of which are connected by wires. Dima remembered that each two lamps in the garland were connected directly or indirectly via some wires. Furthermore, the number of wires was exactly one less than the number of lamps.

There was something unusual about the garland. Each lamp had its own brightness which depended on the temperature of the lamp. Temperatures could be positive, negative or zero. Dima has two friends, so he decided to share the garland with them. He wants to cut two different wires so that the garland breaks up into three parts. Each part of the garland should shine equally, i. e. the sums of lamps' temperatures should be equal in each of the parts. Of course, each of the parts should be non-empty, i. e. each part should contain at least one lamp.

Help Dima to find a suitable way to cut the garland, or determine that this is impossible.

While examining the garland, Dima lifted it up holding by one of the lamps. Thus, each of the lamps, except the one he is holding by, is now hanging on some wire. So, you should print two lamp ids as the answer which denote that Dima should cut the wires these lamps are hanging on. Of course, the lamp Dima is holding the garland by can't be included in the answer.

Input

The first line contains single integer n (3 ≤ n ≤ 106) — the number of lamps in the garland.

Then n lines follow. The i-th of them contain the information about the i-th lamp: the number lamp ai, it is hanging on (and 0, if is there is no such lamp), and its temperature ti ( - 100 ≤ ti ≤ 100). The lamps are numbered from 1 to n.

Output

If there is no solution, print -1.

Otherwise print two integers — the indexes of the lamps which mean Dima should cut the wires they are hanging on. If there are multiple answers, print any of them.

Example
Input
6
2 4
0 5
4 2
2 1
1 1
4 2
Output
1 4
Input
6
2 4
0 6
4 2
2 1
1 1
4 2
Output
-1
Note

The garland and cuts scheme for the first example:

给出一棵树,每个节点都有一个值,或正或负或者零,把树分成三段,使每一段的和都相等
一开始企图从树根开始向下找,发现这样找要考虑好多情况,比如全都是零,或和为零但数不都为零,后来发现从下往上找比较方便。用一个函数递归实现,边求出每个节点的子树及其自身的和边判断是否符合条件。
#include<bits/stdc++.h>
using namespace std;
const int M = 1e6 + 5;
int sum[M];
vector<int> nex[M], ans;//nex存放子节点,ans存放结果
int n, tar;
int s = 0;
void dfs(int x)
{
    vector<int>::iterator it;
    for(it=nex[x].begin();it!=nex[x].end();it++)
    {
        if(ans.size()==2)
            return;
        dfs(*it);
        sum[x] += sum[*it];
    }
    if(ans.size()<2)
    {
        if(tar==sum[x]&&x!=nex[0][0])//不能剪掉根节点
        {
            ans.push_back(x);
            sum[x] = 0;
        }
    }
}
int main()
{
    int t1, t2;
    scanf("%d", &n);
    for(int i=1;i<=n;i++)
    {
        scanf("%d%d", &t1, &sum[i]);
        nex[t1].push_back(i);
        s += sum[i];
    }
    if(s%3==0)
    {
        tar = s / 3;
        dfs(nex[0][0]);//nex[0][0]是根节点
        if(ans.size()==2)
            printf("%d %d", ans[0], ans[1]);
        else
            printf("-1");
    }
    else
        printf("-1");
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值